Bug 1484839 (CVE-2017-12934) - CVE-2017-12934 php: heap use after free in ext/standard/var_unserializer.re
Summary: CVE-2017-12934 php: heap use after free in ext/standard/var_unserializer.re
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2017-12934
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1484840 1554537
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-08-24 11:59 UTC by Adam Mariš
Modified: 2019-09-29 14:19 UTC (History)
5 users (show)

Fixed In Version: php 7.0.21, php 7.1.7
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-06-08 03:22:11 UTC


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2018:1296 0 None None None 2018-05-03 05:08:26 UTC

Description Adam Mariš 2017-08-24 11:59:18 UTC
ext/standard/var_unserializer.re in PHP 7.0.x before 7.0.21 and 7.1.x
before 7.1.7 is prone to a heap use after free while unserializing
untrusted data, related to the zval_get_type function in
Zend/zend_types.h. Exploitation of this issue can have an unspecified
impact on the integrity of PHP.

Upstream bug:

https://bugs.php.net/bug.php?id=74101

Comment 1 Adam Mariš 2017-08-24 12:00:16 UTC
Created php tracking bugs for this issue:

Affects: fedora-all [bug 1484840]

Comment 2 Adam Mariš 2017-08-24 12:04:34 UTC
This issue happens when untrusted input is deserialized. Doing so is documented as being unsafe:

http://php.net/manual/en/function.unserialize.php

"Do not pass untrusted user input to unserialize() regardless of the options value of allowed_classes. Unserialization can result in code being loaded and executed due to object instantiation and autoloading, and a malicious user may be able to exploit this. Use a safe, standard data interchange format such as JSON (via json_decode() and json_encode()) if you need to pass serialized data to the user."

"If you need to unserialize externally stored serialized data, consider to use hash_hmac() for data validation. Make sure data is not modified by anyone, but you."

Comment 4 errata-xmlrpc 2018-05-03 05:08:19 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 6
  Red Hat Software Collections for Red Hat Enterprise Linux 6.7 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7
  Red Hat Software Collections for Red Hat Enterprise Linux 7.3 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.4 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.5 EUS

Via RHSA-2018:1296 https://access.redhat.com/errata/RHSA-2018:1296


Note You need to log in before you can comment on or make changes to this bug.